/*
 * CDLCompilerGroup.java
 *
 * Created on 1st March 2001
 * Modified on 11th April 2003
 */

package cz.cuni.dsrg.sofa.netbeans.cdl;

import cz.cuni.dsrg.sofa.netbeans.settings.SofaSettings;
import cz.cuni.dsrg.sofa.netbeans.tirbrowser.*;
import org.openide.cookies.SaveCookie;
import org.openide.nodes.FilterNode;
import org.openide.nodes.Node;
import org.openide.util.NbBundle;
import org.openide.windows.TopComponent;
import org.openide.windows.WindowManager;


public class CDLCompilerGroup extends org.openide.compiler.CompilerGroup 
{
    CDLCompiler comp;


    /** Creates new CDLCompilerGroup */
    public CDLCompilerGroup() 
    {
    }
    
   void setPrior(ThreadGroup grp) 
  {
    int i;
    int tcnt = grp.activeCount();
    Thread[] all = new Thread [tcnt];
    grp.enumerate(all);
    for (i=0;i<all.length;i++) 
    {
      if (all[i]!=null)
         all[i].setPriority(Thread.MIN_PRIORITY);
    }
    tcnt = grp.activeGroupCount();
    ThreadGroup[] allgrp = new ThreadGroup [tcnt];
    for (i=0;i<allgrp.length;i++) 
     if (allgrp[i]!=null)
         setPrior(allgrp[i]);
 }



 public boolean start() 
 {
     OpenedWorkRepository owr = (OpenedWorkRepository) org.openide.util.SharedClassObject.findObject(OpenedWorkRepository.class);
     SOFA.SOFAnode.Made.TIR.WorkRepository workRep;
     SOFA.SOFAnode.Made.TIR.Repository defRep;
     SOFA.SOFAnode.Made.CDL.Output.out.reset();
     SofaSettings settings = (SofaSettings) org.openide.util.SharedClassObject.findObject(SofaSettings.class);
     if ((workRep = owr.getRepository()) == null)
     {
       SOFA.SOFAnode.Made.CDL.Output.out.println(NbBundle.getMessage (CDLCompilerGroup.class, "MSG_NoOpenedWorkRepository"));
       return false;
     }
      else
     {
       // really compile

   // saving file before compiling
      TopComponent[] tc= WindowManager.getDefault().getCurrentWorkspace().findMode("editor").getTopComponents();
         for(int i=0; i<tc.length; i++)
         {
            if(tc[i].getName().equalsIgnoreCase(comp.getFileObject().getName()+" *"))
          {
              Node f[]= tc[i].getActivatedNodes();
              for(i=0; i<f.length; i++)
              {
                  Node.Cookie c;
                  if((c=(f[i].getCookie(SaveCookie.class)))!=null)
                  {
                      try {((SaveCookie) c).save();} catch (Exception e){};
                      break;
                  }
              }
          }
        }   // end saving file
       defRep = owr.getOldrepository();
       try
       {
        SOFA.SOFAnode.Made.CDL.parser.doParse(comp.getFileObject().getInputStream(), comp.getFileObject().getName() ,defRep, workRep, settings.isUseprotocols(), settings.isTestprotocols());
        FilterNode no = owr.getRepnode();
        RepositoryCookie rc= (RepositoryCookie) no.getCookie(RepositoryCookieImpl.class);
        org.openide.nodes.Node[] ns = rc.getRepositoryRootChildren().getNodes();

        RefreshableNode rnn;
        for (int i=0;i<ns.length;i++)
        {
          if((rnn= (RefreshableNode)ns[i].getCookie(TIRContainerRefresh.class))==null)
           if((rnn= (RefreshableNode)ns[i].getCookie(TIRProfilesRefresh.class))==null)
            if ((rnn= (RefreshableNode)ns[i].getCookie(ProfileRefresh.class))==null)
             throw new NullPointerException("Null exception - There is no known class implementing the refresh cookie for node "+ns[i].getName());

             rnn.refresh();
        }

        SOFA.SOFAnode.Made.CDL.Output.out.println("File "+comp.getFileObject().getName()+" successfully compiled.");
        return true;
     }


       catch (Exception e)
       {
        SOFA.SOFAnode.Made.CDL.Output.out.println(e.getMessage());
        e.printStackTrace();
        FilterNode rn = owr.getRepnode();
        RepositoryCookie rcn= (RepositoryCookie) rn.getCookie(RepositoryCookieImpl.class);

        boolean result = false;
        try
        {
         result = workRep.abort();
         if (!result)
          SOFA.SOFAnode.Made.CDL.Output.out.println("Something wrong happens during abort");
        }
        catch (java.rmi.RemoteException ex)
        {
          MiscHelps.exception(ex);
        }
        owr.setRepository(null);
        rcn.unsetWork(owr.getOldrepository());
        owr.setOldrepository(null);
        owr.setRepnode(null);
        return false;
      }
            
    }
   }




    public void add(org.openide.compiler.Compiler c) throws java.lang.IllegalArgumentException
    {
        if (! (c instanceof CDLCompiler)) throw new IllegalArgumentException();
        comp = (CDLCompiler) c;
    }
    
}
