package cz.cuni.dsrg.sofa.netbeans.cdl;

import org.openide.loaders.DataNode;
import org.openide.nodes.Children;
import org.openide.nodes.CookieSet;
import org.openide.nodes.FilterNode;
import org.openide.filesystems.FileLock;
import org.openide.util.NbBundle;
import cz.cuni.dsrg.sofa.netbeans.tirbrowser.*;
import cz.cuni.dsrg.sofa.netbeans.settings.SofaSettings;

/** A node to represent this object.
 *
 * @author  hnetynka
 */
public class CDLDataNode extends DataNode implements CDLCompileCookie 
 {
   public CDLDataNode (CDLDataObject obj) 
   {
     this (obj, Children.LEAF);
   }

    public CDLDataNode (CDLDataObject obj, Children ch) 
    {
        super (obj, ch);
        setIconBase ("cz/cuni/dsrg/sofa/netbeans/resources/cdl/CDLDataIcon");
        
        CookieSet cookies = getCookieSet ();
        cookies.add (this);
    }

    protected CDLDataObject getCDLDataObject () 
    {
        return (CDLDataObject) getDataObject ();
    }


    public void compile() 
    {

        CDLDataObject dObj = getCDLDataObject();
        FileLock fl = dObj.getLock();

        Thread.currentThread().setPriority(Thread.MAX_PRIORITY);

        OpenedWorkRepository owr = (OpenedWorkRepository) org.openide.util.SharedClassObject.findObject(OpenedWorkRepository.class);
        SOFA.SOFAnode.Made.TIR.WorkRepository workRep;
        SOFA.SOFAnode.Made.TIR.Repository defRep;
        SOFA.SOFAnode.Made.CDL.Output.out.reset();
        SofaSettings settings = (SofaSettings) org.openide.util.SharedClassObject.findObject(SofaSettings.class);
        if ((workRep = owr.getRepository()) == null) 
        {
            SOFA.SOFAnode.Made.CDL.Output.out.println(NbBundle.getMessage (CDLCompileAction.class, "MSG_NoOpenedWorkRepository"));
            fl.releaseLock();
            return;
        } 
        else 
        {
         SOFA.SOFAnode.Made.CDL.Output.out.println("Really compile");
            // really compile
            defRep = owr.getOldrepository();
            try 
            {
                SOFA.SOFAnode.Made.CDL.Output.out.println("Compiling file "+dObj.getPrimaryFile().getName()+"...");

                SOFA.SOFAnode.Made.CDL.parser.doParse(dObj.getPrimaryFile().getInputStream(), dObj.getPrimaryFile().getName() ,defRep, workRep, settings.isUseprotocols(), settings.isTestprotocols());

                FilterNode no = owr.getRepnode();
                RepositoryCookie rc = (RepositoryCookie) no.getCookie(RepositoryCookieImpl.class);
                org.openide.nodes.Node[] ns = rc.getRepositoryRootChildren().getNodes();


                for (int i=0;i<ns.length;i++)
                {
                    ((RefreshableNode) ns[i]).refresh();
                }
                
               SOFA.SOFAnode.Made.CDL.Output.out.println("File "+dObj.getPrimaryFile().getName()+" successfully compiled.");
                fl.releaseLock();
                return;
            } 
            catch (Exception e) 
            {
               SOFA.SOFAnode.Made.CDL.Output.out.println(e.getMessage());


                FilterNode rn = owr.getRepnode();
                RepositoryCookie rnc= (RepositoryCookie) rn.getCookie(RepositoryCookieImpl.class);

                boolean result = false;
                try 
                {
                    result = workRep.abort();
                    if (!result)
                        SOFA.SOFAnode.Made.CDL.Output.out.println("Something wrong happens during abort");
                } catch (java.rmi.RemoteException ex) 
                {
                    MiscHelps.exception(ex);
                }
                owr.setRepository(null);
                rnc.unsetWork(owr.getOldrepository());
                owr.setOldrepository(null);
                owr.setRepnode(null);     
                fl.releaseLock();
                return;
            }
            
            
        }
      
   }
}
