package cz.cuni.dsrg.sofa.netbeans.cdl;

import org.openide.cookies.SaveCookie;
import org.openide.filesystems.FileLock;
import org.openide.filesystems.FileObject;
import org.openide.loaders.DataObjectExistsException;
import org.openide.loaders.MultiDataObject;
import org.openide.nodes.CookieSet;
import org.openide.nodes.Node;
import org.openide.util.HelpCtx;

/** Represents a CDL object in the Repository.
 *
 * @author  hnetynka
 */
public class CDLDataObject extends MultiDataObject 
{

 public CDLDataObject (FileObject pf, CDLDataLoader loader) throws DataObjectExistsException 
 {
   super (pf, loader);
   init ();
 }

 private void init () 
 {
   CookieSet cookies = getCookieSet ();
  // Add whatever capabilities you need, e.g.:
   /*
    cookies.add (new ExecSupport (getPrimaryEntry ()));
    cookies.add (new EditorSupport (getPrimaryEntry ()));
  */ 
   
   cookies.add (new CDLCompilerSupport.Compile (getPrimaryEntry ()));
  /*
   cookies.add (new CompilerSupport.Build (getPrimaryEntry ()));
   cookies.add (new CompilerSupport.Clean (getPrimaryEntry ()));
  */
 
  cookies.add (new CDLEditorSupport(this));
  /*
   cookies.add (new OpenCookie () 
   {
     public void open () 
     {
	 // do something...but usually you want to use OpenSupport instead
     }
    });
        */
  }

  public HelpCtx getHelpCtx () 
  {
    return HelpCtx.DEFAULT_HELP;
      // If you add context help, change to:
      // return new HelpCtx (CDLDataObject.class);
  }

  protected Node createNodeDelegate () 
  {
    return new CDLDataNode (this);
  }

  void addSaveCookie(SaveCookie cookie) 
  {
     getCookieSet().add(cookie);
  }
    
  void removeSaveCookie(SaveCookie cookie) 
  {
     getCookieSet().remove(cookie);
  }
    
  
  FileLock getLock() 
  {
   try 
   {
     return takePrimaryFileLock();
   } 
   catch (java.io.IOException e) 
   {
     return null;
   }
  }
}