package cz.cuni.dsrg.sofa.netbeans.settings;

import org.openide.options.SystemOption;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;


public class VDSettings extends SystemOption
{
   // static final long serialVersionUID = ...;

    public static final String PROP_MODULE = "Module";
    public static final String PROP_PROVIDER ="Provider";

    // No constructor please!

    protected void initialize () 
    {
        // If you have more complex default values which might require
        // other parts of the module to already be installed, do not
        // put them here; e.g. make the getter return them as a
        // default if getProperty returns null. (The class might be
        // initialized partway through module installation.)

        super.initialize();

        setModule ("SOFA");
        setProvider ("CUNI::SOFA");
    }


    public String displayName()
    {
        return NbBundle.getMessage(VDSettings.class, "LBL_vdsettings");
    }

    
    public HelpCtx getHelpCtx() 
    {
        return HelpCtx.DEFAULT_HELP;
        // If you provide context help then use:
        // return new HelpCtx (SofaSettings.class);
    }

    
    /** Default instance of this system option, for the convenience of associated classes. */
    public static VDSettings getDefault ()
    {
        return (VDSettings) findObject (VDSettings.class, true);
    }

  
    public String getModule()
    {
        return (String) getProperty (PROP_MODULE);
    }

   
    public void setModule(String module)
    {
      putProperty (PROP_MODULE, module, true);
    }
    
   
   
    public String getProvider ()
    {
        return  (String) getProperty (PROP_PROVIDER);
    }

    public void setProvider(String provider)
    {
         putProperty (PROP_PROVIDER, provider, true);
    }
    


    /** Makes that they are profile options */
//    public final boolean isGlobal()
//    {
//        return true;
//    }
}
