package cz.cuni.dsrg.sofa.netbeans.tirbrowser;

import org.openide.nodes.FilterNode;
import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.NodeAction;

/** Action sensitive to the node selection that does something useful.
 *
 * @author  hnetynka
 */

public class AbortTrAction extends NodeAction 
{
  RepositoryCookie rc;

  protected void performAction (Node[] nodes)
 {
   OpenedWorkRepository owr = (OpenedWorkRepository) org.openide.util.SharedClassObject.findObject(OpenedWorkRepository.class);
   FilterNode fn = (FilterNode) nodes[0];
   FilterNode fn2= (FilterNode) nodes[0].getChildren().findChild("Profiles");

   rc= (RepositoryCookie) fn.getCookie(RepositoryCookieImpl.class);
   InstrumentalCookie ic= (InstrumentalCookie) fn2.getCookie(TIRProfilesRefresh.class);
   RefreshableNode rn= (RefreshableNode) fn2.getCookie(TIRProfilesRefresh.class);
   boolean result = false;
   try 
   {
     result = ((SOFA.SOFAnode.Made.TIR.WorkRepository)rc.getTIR()).abort();
     if (!result)
      MiscHelps.message("Something wrong happens during abort");

     ic.setTIRProfile(owr.getOldrepository().getProfiles());      // setting profile variable in the TIRProfilesRefresh to the proper value
     rn.refresh();

       owr.setRepository(null);
       rc.unsetWork(owr.getOldrepository());
       owr.setOldrepository(null);
       owr.setRepnode(null);

   }
   catch (java.rmi.RemoteException e) 
   {
    MiscHelps.exception(e);
   }
   
 }

 
 
 protected boolean enable (Node[] nodes) 
 {
   FilterNode rn = (FilterNode) nodes[0];
   rc= (RepositoryCookie) rn.getCookie(RepositoryCookieImpl.class);
   return rc.isWork();
 }

 public String getName ()
 {
   return NbBundle.getMessage (AbortTrAction.class, "LBL_AbortAction");
 }

 protected String iconResource ()
 {
  return "cz/cuni/dsrg/sofa/netbeans/resources/tirbrowser/AbortTrActionIcon.gif";
 }

 public HelpCtx getHelpCtx ()
 {
   return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx (AbortTrAction.class);
 }

    /** Perform extra initialization of this action's singleton.
     * PLEASE do not use constructors for this purpose!
    protected void initialize () {
	super.initialize ();
        putProperty (Action.SHORT_DESCRIPTION, NbBundle.getMessage (AbortTrAction.class, "HINT_Action"));
    }
    */

}
