package cz.cuni.dsrg.sofa.netbeans.tirbrowser;

import cz.cuni.dsrg.sofa.netbeans.settings.SofaSettings;
import org.openide.nodes.FilterNode;
import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.NodeAction;

/** Action sensitive to the node selection that does something useful.
 *
 * @author  hnetynka
 */

public class BeginTrAction extends NodeAction 
{
   RepositoryCookie rc;

    protected void performAction (Node[] nodes)
  {
    OpenedWorkRepository owr = (OpenedWorkRepository) org.openide.util.SharedClassObject.findObject(OpenedWorkRepository.class, true);

      SOFA.SOFAnode.Made.TIR.Repository t;

    FilterNode fn = (FilterNode) nodes[0];
    rc= (RepositoryCookie) fn.getCookie(RepositoryCookieImpl.class);

    SofaSettings settings = (SofaSettings) org.openide.options.SystemOption.findObject(SofaSettings.class, true);
    String profName = settings.getProfile();

    SOFA.SOFAnode.Made.TIR.ProfileDef profile = null;
    SOFA.SOFAnode.Made.TIR.WorkRepository workRep = null;



    if (profName!= null && profName.compareTo("")!=0)
    {
      try
      {
       t= rc.getTIR();                                       // vraci prom. tir z rootRepository typu Repository
       profile = t.getProfiles().lookup(profName);
       if (profile == null)
       {
         MiscHelps.message("Specified profile doesn't exist.");
         return;
       }
     }
     catch (SOFA.SOFAnode.Made.TIR.TIRException e)
     {
        MiscHelps.exception(e);
     }
     catch (java.rmi.RemoteException e)
     {
        MiscHelps.exception(e);
     }
   }

   try
   {
      //System.out.println(java.util.Calendar.getInstance().getTime().getTime());
     t= rc.getTIR();
     workRep = t.beginChanges(profile);     // vraci nasi vlastni WorkRepository, na ktere se daji volat "create_" metody
      //System.out.println(java.util.Calendar.getInstance().getTime().getTime());

       owr.setRepository(workRep);

       owr.setOldrepository(rc.getTIR());
       owr.setRepnode((FilterNode) nodes[0]);
       rc.setWork(workRep);
   }

   catch (SOFA.SOFAnode.Made.TIR.TIRException e)
   {
     MiscHelps.exception(e);
   }

   catch (java.rmi.RemoteException e)
   {
     MiscHelps.exception(e);
   }

 }



 protected boolean enable (Node[] nodes) 
 {

    OpenedWorkRepository owr = (OpenedWorkRepository) org.openide.util.SharedClassObject.findObject(OpenedWorkRepository.class);
    SOFA.SOFAnode.Made.TIR.Repository rep = owr.getRepository();
    if (rep == null) return true;
    return false;
 }

 
  public String getName () 
  {
    return NbBundle.getMessage (BeginTrAction.class, "LBL_BeginAction");
  }

 protected String iconResource () 
 {
   return "cz/cuni/dsrg/sofa/netbeans/resources/tirbrowser/BeginTrActionIcon.gif";
 }

 
  public HelpCtx getHelpCtx () 
  {
    return HelpCtx.DEFAULT_HELP;
    // If you will provide context help then use:
    // return new HelpCtx (BeginTrAction.class);
  }

  
  
    /** Perform extra initialization of this action's singleton.
     * PLEASE do not use constructors for this purpose!
    protected void initialize () {
	super.initialize ();
        putProperty (Action.SHORT_DESCRIPTION, NbBundle.getMessage (BeginTrAction.class, "HINT_Action"));
    }
    */

}
