package cz.cuni.dsrg.sofa.netbeans.tirbrowser;

import org.openide.nodes.FilterNode;
import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.NodeAction;

/** Action sensitive to the node selection that does something useful.
 *
 * @author  hnetynka
 */

public class CommitTrAction extends NodeAction 
{
   RepositoryCookie rc;

 protected void performAction (Node[] nodes)
 {
   OpenedWorkRepository owr = (OpenedWorkRepository) org.openide.util.SharedClassObject.findObject(OpenedWorkRepository.class);
   // RepositoryRootNode rn = (RepositoryRootNode) nodes[0];
   FilterNode fn = (FilterNode) nodes[0];
   rc= (RepositoryCookie) fn.getCookie(RepositoryCookieImpl.class);

   boolean result = false;
   try
   {
     result = ((SOFA.SOFAnode.Made.TIR.WorkRepository)rc.getTIR()).commit();
     if (!result)
       MiscHelps.message("Something wrong happens during commit");
  } 
  catch (java.rmi.RemoteException e) 
  {
    MiscHelps.exception(e);
  } 
  catch (SOFA.SOFAnode.Made.TIR.TIRExceptCommit e)
  {
     MiscHelps.exception(e);
  }
  owr.setRepository(null);
  rc.unsetWork(owr.getOldrepository());
  owr.setOldrepository(null);
  owr.setRepnode(null);
 }

 
 protected boolean enable (Node[] nodes) 
 {
     FilterNode fn = (FilterNode) nodes[0];
     rc= (RepositoryCookie) fn.getCookie(RepositoryCookieImpl.class);
     return rc.isWork();
 }

 
 public String getName () 
 {
   return NbBundle.getMessage (CommitTrAction.class, "LBL_CommitAction");
 }

 protected String iconResource () 
 {
   return "cz/cuni/dsrg/sofa/netbeans/resources/tirbrowser/CommitTrActionIcon.gif";
 }

  public HelpCtx getHelpCtx () 
  {
        return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx (CommitTrAction.class);
  }

    /** Perform extra initialization of this action's singleton.
     * PLEASE do not use constructors for this purpose!
    protected void initialize () {
	super.initialize ();
        putProperty (Action.SHORT_DESCRIPTION, NbBundle.getMessage (CommitTrAction.class, "HINT_Action"));
    }
    */

}
