package cz.cuni.dsrg.sofa.netbeans.tirbrowser;

import SOFA.SOFAnode.Made.CodeGen.GenerException;
import SOFA.SOFAnode.Made.CodeGen.TIRAccessException;
import SOFA.SOFAnode.Made.TIR.ArchitectureDef;
import cz.cuni.dsrg.sofa.netbeans.settings.SofaSettings;
import org.openide.TopManager;
import org.openide.nodes.FilterNode;
import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.NodeAction;

import java.io.IOException;

/**
 * Created by T.OP.
 * Date: 11.4.2003
 */

public class GenerateAction extends NodeAction
{
  RepositoryCookie rc;

    protected void performAction(Node[] nodes)
    {

        SofaSettings settings= (SofaSettings) org.openide.options.SystemOption.findObject(SofaSettings.class, true);
        String codegendir= settings.getGencodedir();

        ContainerCookie rn= (ContainerCookie) nodes[0].getCookie(TIRContainerRefresh.class);
        ArchitectureDef[] ad= new  ArchitectureDef[1];

        ad[0]= (ArchitectureDef) rn.getContainer();
        SOFA.SOFAnode.Made.CodeGen.Generator gen;
        System.setProperty("codegen.dir", codegendir);

        try
        {
            gen= new SOFA.SOFAnode.Made.CodeGen.Generator(rc.getTIR(), ad);
            TopManager.getDefault().setStatusText("Generating component mappings to Java ...");
            gen.generate();
            TopManager.getDefault().setStatusText("");
            MiscHelps.message("Code generation completed sucessfully!");
        }
        catch (IOException e)
        {
            MiscHelps.message("Code generation failed: IOException "+ e.toString());
            e.printStackTrace();
        }
        catch (TIRAccessException e)
        {
            MiscHelps.message("Code generation failed: TIRAccessException "+ e.toString());
            e.printStackTrace();
        }
        catch (GenerException e)
        {
            MiscHelps.message("Code generation failed: General exception"+ e.toString());
            e.printStackTrace();
        }
    TopManager.getDefault().setStatusText("");
    }

    protected boolean enable(Node[] nodes)
    {
      /**
       * enabled only on commited tir, i.e. if the repository is not open
        */

     FilterNode f= (FilterNode) nodes[0];
     do
       f= (FilterNode) f.getParentNode();
     while ((rc= (RepositoryCookie) f.getCookie(RepositoryCookieImpl.class))==null);

     if(rc.isWork()) return false; else return true;
   }


    public String getName()
    {
        return NbBundle.getMessage (GenerateAction.class, "LBL_GenerateAction");
    }

    public HelpCtx getHelpCtx()
    {
        return HelpCtx.DEFAULT_HELP;
    }
}
