package cz.cuni.dsrg.sofa.netbeans.tirbrowser;

import org.openide.nodes.FilterNode;
import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.NodeAction;

/** Shows active TIR sessions.
 *
 * @author  Petr Hnetynka
 */


public class ManageRepositoryAction extends NodeAction 
{
  RepositoryCookie rc;

    protected void performAction (Node[] nodes)
    {
        try 
        {
            FilterNode fn= (FilterNode) nodes[0];
            rc= (RepositoryCookie) fn.getCookie(RepositoryCookieImpl.class);

            SOFA.SOFAnode.Made.TIR.ManageRepository rep = rc.getManageRepository();
            
            org.openide.TopManager tp = org.openide.TopManager.getDefault();
            ManageRepositoryPanel panel = new ManageRepositoryPanel(rep);
            org.openide.DialogDescriptor dd = new org.openide.DialogDescriptor(panel, getName());
            java.awt.Dialog d = tp.createDialog(dd);
            d.pack();
            d.show();
        }
       catch (Exception e) 
       {
          MiscHelps.exception(e);
          return;
       }
        
    }



    protected boolean enable (Node[] nodes) 
    {
        FilterNode fn = (FilterNode) nodes[0];
        rc= (RepositoryCookie) fn.getCookie(RepositoryCookieImpl.class);
        return !rc.isWork();
    }

    
    
    public String getName () 
    {
        return NbBundle.getMessage (ManageRepositoryAction.class, "LBL_ManageRepositoryAction");
    }

    
    protected String iconResource () 
    {
        return "cz/cuni/dsrg/sofa/netbeans/resources/tirbrowser/ManageRepositoryActionIcon.gif";
    }

    
    public HelpCtx getHelpCtx () 
    {
        return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx (ManageRepositoryAction.class);
    }




    /** Perform extra initialization of this action's singleton.
     * PLEASE do not use constructors for this purpose!
    protected void initialize () 
    {
	super.initialize ();
        putProperty (Action.SHORT_DESCRIPTION, NbBundle.getMessage (ManageRepositoryAction.class, "HINT_Action"));
    }
    */

}
