/*
 * ManageRepositoryPanel.java
 *
 * Created on 19. unor 2001, 12:30
 */

package cz.cuni.dsrg.sofa.netbeans.tirbrowser;

/**
 *
 * @author Petr Hnetynka
 */
public class ManageRepositoryPanel extends javax.swing.JPanel 
{
    SOFA.SOFAnode.Made.TIR.WorkRepository[] wr;
    SOFA.SOFAnode.Made.TIR.ManageRepository rep;


    /** Creates new form ManageRepositoryPanel */
    public ManageRepositoryPanel(SOFA.SOFAnode.Made.TIR.ManageRepository rep) throws java.rmi.RemoteException
    {
        initComponents();
        this.rep = rep;
        reloadContentOfList();
        abortButton.addActionListener(new abortButtonListener(wr));
        reloadButton.addActionListener(new reloadButtonListener());
    }
    


    private void reloadContentOfList() throws java.rmi.RemoteException 
    {
        wr = rep.getActiveWork();
        String[] ids = new String [wr.length];
        for (int i=0;i<wr.length;i++) 
        {
            ids[i] = wr[i].workIdent();
        }
        manageList.setListData(ids);
    }



    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    private void initComponents()
    {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jScrollPane2 = new javax.swing.JScrollPane();
        manageList = new javax.swing.JList();
        abortButton = new javax.swing.JButton();
        reloadButton = new javax.swing.JButton();

        setLayout(new java.awt.GridBagLayout());

        jScrollPane2.setMinimumSize(new java.awt.Dimension(203, 103));
        manageList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        manageList.setMinimumSize(new java.awt.Dimension(200, 100));
        manageList.setPreferredSize(new java.awt.Dimension(200, 100));
        jScrollPane2.setViewportView(manageList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        add(jScrollPane2, gridBagConstraints);

        abortButton.setText("Abort connection      ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        add(abortButton, gridBagConstraints);

        reloadButton.setText("Refresh connections");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.RELATIVE;
        gridBagConstraints.gridheight = java.awt.GridBagConstraints.RELATIVE;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        add(reloadButton, gridBagConstraints);

    }//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton reloadButton;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JList manageList;
    private javax.swing.JButton abortButton;
    // End of variables declaration//GEN-END:variables

    private class abortButtonListener implements java.awt.event.ActionListener 
    { 
        SOFA.SOFAnode.Made.TIR.WorkRepository[] wr;
        public abortButtonListener(SOFA.SOFAnode.Made.TIR.WorkRepository[] wr)
        {
            this.wr = wr;
        }

        public void actionPerformed(java.awt.event.ActionEvent e) 
        {
            if (!manageList.isSelectionEmpty()) 
            {
                try 
                {
                    wr[manageList.getSelectedIndex()].abort();
                    reloadContentOfList();
                } 
                catch (java.rmi.RemoteException ex) 
                {
                    MiscHelps.exception(ex);
                }
            }
        }
    }
    


    private class reloadButtonListener implements java.awt.event.ActionListener 
    { 
        public void actionPerformed(java.awt.event.ActionEvent e) 
        {
            try 
            {
                reloadContentOfList();
            } 
            catch (java.rmi.RemoteException ex) 
            {
                MiscHelps.exception(ex);
            }
        }
    }
}
