/*
 * MiscHelps.java
 *
 * Created on 17. leden 2001, 9:57
 */

package cz.cuni.dsrg.sofa.netbeans.tirbrowser;
import SOFA.SOFAnode.Made.TIR.*;
import org.openide.ErrorManager;

import java.rmi.RemoteException;

/** some useful methods
 *
 * @author  Petr Hnetynka
 * @version 
 */
public class MiscHelps 
{

  public static String printKind(DefinitionKind dk) throws RemoteException 
  {
    switch (dk.value()) 
    {
      case DefinitionKind.dk_Attribute : return("Attribute"); 
      case DefinitionKind.dk_Constant : return("Constant"); 
      case DefinitionKind.dk_Exception : return("Exception"); 
      case DefinitionKind.dk_Interface : return("Interface"); 
      case DefinitionKind.dk_Module : return("Module"); 
      case DefinitionKind.dk_Operation : return("Operation"); 
      case DefinitionKind.dk_Typedef : return("Typedef"); 
      case DefinitionKind.dk_Struct : return("Struct"); 
      case DefinitionKind.dk_Union : return("Union"); 
      case DefinitionKind.dk_Enum : return("Enum"); 
      case DefinitionKind.dk_Primitive : return("Primitive"); 
      case DefinitionKind.dk_String : return("String"); 
      case DefinitionKind.dk_Sequence : return("Sequence"); 
      case DefinitionKind.dk_Array : return("Array"); 
      case DefinitionKind.dk_Repository : return("Repository"); 
      case DefinitionKind.dk_Frame : return("Frame"); 
      case DefinitionKind.dk_Architecture : return("Architecture"); 
      case DefinitionKind.dk_Provides : return("Provides"); 
      case DefinitionKind.dk_Requires : return("Requires"); 
      case DefinitionKind.dk_Property : return("Property"); 
      case DefinitionKind.dk_Implements : return("Implements"); 
      case DefinitionKind.dk_Inst : return("Inst"); 
      case DefinitionKind.dk_Bind : return("Bind"); 
      case DefinitionKind.dk_Protocol : return("Protocol"); 
      case DefinitionKind.dk_StructMember : return("StructMember"); 
      case DefinitionKind.dk_EnumMember : return("EnumMember"); 
      case DefinitionKind.dk_UnionMember : return("UnionMember"); 
      case DefinitionKind.dk_Expression : return("Expression"); 
      case DefinitionKind.dk_ProtocolOper : return("ProtocolOper"); 
      case DefinitionKind.dk_ValueGen : return("ValueGen"); 
      case DefinitionKind.dk_ValueGenElem : return("ValueGenOper"); 
      case DefinitionKind.dk_BindOper : return("BindOper"); 
      case DefinitionKind.dk_Provider : return("Provider"); 
      case DefinitionKind.dk_AModule : return("AModule"); 
      case DefinitionKind.dk_Wstring : return("Wstring"); 
      case DefinitionKind.dk_Fixed : return("Fixed");
      case DefinitionKind.dk_CDLRepository : return "CDL";
    }
    return "XXXXXXXX";
  }
  
  
  
  public static boolean isModuleLike(DefinitionKind dk) throws RemoteException 
  {
      switch (dk.value()) 
      {
          case DefinitionKind.dk_Module:
          case DefinitionKind.dk_AModule:
          case DefinitionKind.dk_Provider:
          case DefinitionKind.dk_CDLRepository:
              return true;
      };
      return false;
  }
  


  public static String cdlType2String(CDLType type) throws RemoteException 
  {
      StringBuffer result = new StringBuffer();
      int dkInt = type.get_def_kind().value();
      switch (dkInt) 
      {
          case DefinitionKind.dk_Array:
              result.append(cdlType2String(((ArrayDef)type).element_type()));
              result.append("[]");
              break;
          case DefinitionKind.dk_Fixed:
              result.append("fixed");
              break;
          case DefinitionKind.dk_String:
              result.append("string");
              break;
          case DefinitionKind.dk_Wstring:
              result.append("wstring");
              break;
          case DefinitionKind.dk_Sequence:
              result.append(((SequenceDef)type).element_type());
              result.append("<>");
              break;
          case DefinitionKind.dk_Primitive:
              switch (((PrimitiveDef)type).kind().value()) 
              {
                  case PrimitiveKind.pk_any: result.append("any"); break;
                  case PrimitiveKind.pk_boolean: result.append("boolean"); break;
                  case PrimitiveKind.pk_char: result.append("char"); break;
                  case PrimitiveKind.pk_double: result.append("double"); break;
                  case PrimitiveKind.pk_float: result.append("float"); break;
                  case PrimitiveKind.pk_long: result.append("long"); break;
                  case PrimitiveKind.pk_longdouble: result.append("long double"); break;
                  case PrimitiveKind.pk_longlong: result.append("long long"); break;
                  case PrimitiveKind.pk_object: result.append("object"); break;
                  case PrimitiveKind.pk_octet: result.append("octet"); break;
                  case PrimitiveKind.pk_short: result.append("short"); break;
                  case PrimitiveKind.pk_string: result.append("string"); break;
                  case PrimitiveKind.pk_ulong: result.append("unsigned long"); break;
                  case PrimitiveKind.pk_ulonglong: result.append("unsigned long long"); break;
                  case PrimitiveKind.pk_ushort: result.append("unsigned short"); break;
                  case PrimitiveKind.pk_void: result.append("void"); break;
                  case PrimitiveKind.pk_wchar: result.append("wchar"); break;
                  case PrimitiveKind.pk_wstring: result.append("wstring"); break;
              }
              break;
          default:
              result.append(((Contained)type).get_identification().absolute_name().name());
              result.append("?");
              result.append(((Contained)type).get_identification().version());
              break;
      }
      return result.toString();
  }
  

  public static void message(String mesg) 
  {
      org.openide.TopManager tm = org.openide.TopManager.getDefault();
      tm.notify(new org.openide.NotifyDescriptor.Message(mesg));
  }
  

  public static void exception(Throwable ex) 
  {
      ErrorManager.getDefault().notify(ex);
  }
}
