/*
 * OpenedWorkRepository.java
 *
 * Created on 21. unor 2001, 12:10
 */

package cz.cuni.dsrg.sofa.netbeans.tirbrowser;

import org.openide.nodes.FilterNode;

/** Reference to currently opened WorkRepository
 *
 * @author  Petr Hnetynka
 * @version 
 */
public class OpenedWorkRepository extends org.openide.util.SharedClassObject 
{
    public static final String PROP_REPOSITORY = "Repository";
    public static final String PROP_OLDREPOSITORY = "OldRepository";
    public static final String PROP_REPNODE = "Node";
    public static final String PROP_TEST = "Test";
    
    /** no constuctor */
    protected void initialize () 
    {
        setRepository(null);
        setOldrepository(null);
        setRepnode(null);
        setTest(1);
    }
    

    public void setRepository(SOFA.SOFAnode.Made.TIR.WorkRepository rep)
    {
        putProperty (PROP_REPOSITORY, rep, true);
    }


    public SOFA.SOFAnode.Made.TIR.WorkRepository getRepository()
    {
        return (SOFA.SOFAnode.Made.TIR.WorkRepository) getProperty (PROP_REPOSITORY);
    }
    

    public void setOldrepository(SOFA.SOFAnode.Made.TIR.Repository rep)
    {
        putProperty (PROP_OLDREPOSITORY, rep, true);
    }


    public SOFA.SOFAnode.Made.TIR.Repository getOldrepository()
    {
        return (SOFA.SOFAnode.Made.TIR.Repository) getProperty (PROP_OLDREPOSITORY);
    }
    

    public void setTest(int test) 
    {
        putProperty (PROP_TEST, new Integer(test), true);
    }
    

    public int getTest() 
    {
        return ((Integer) getProperty (PROP_TEST)).intValue();
    }
    

    public void setRepnode(FilterNode rep)               // zmenil jsem z RepositoryRootNode
    {
        putProperty (PROP_REPNODE, rep, true);
    }


    public FilterNode getRepnode()                     // zmenil jsem z RepositoryRootNode
    {
        return (FilterNode) getProperty (PROP_REPNODE);
    }
}
