package cz.cuni.dsrg.sofa.netbeans.tirbrowser;

import org.openide.nodes.FilterNode;
import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.actions.NodeAction;

/** Action sensitive to the node selection that does something useful.
 *
 * @author  Ptr Hnetynka
 */
public class RefreshNodeAction extends NodeAction 
{
    FilterNode f;
    RefreshableNode rn;

    protected void performAction (Node[] nodes)
    {
        // do work based on the current node selection, e.g.:
        //MyKindOfNode node = (MyKindOfNode) nodes[0];
        // ...
        for(int i=0;i<nodes.length;i++) 
        {
            f= (FilterNode) nodes[i];
            if((rn= (RefreshableNode)f.getCookie(TIRContainerRefresh.class)) == null)
             if((rn= (RefreshableNode)f.getCookie(TIRProfilesRefresh.class)) == null)
              if((rn= (RefreshableNode)f.getCookie(ProfileRefresh.class)) == null)
               System.err.println("Error: No cookies for known refreshable nodes");

            rn.refresh();
       }
    }


    protected boolean enable (Node[] nodes) 
    {
        // e.g.:
        //return nodes.length == 1 && nodes[0] instanceof MyKindOfNode;
        return true;
    }



    public String getName () 
    {
        return "Refresh";
    }


    protected String iconResource () 
    {
        return "cz/cuni/dsrg/sofa/netbeans/resources/tirbrowser/__NAME__Icon.gif";
    }


    public HelpCtx getHelpCtx () 
    {
        return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx (RefreshNodeAction.class);
    }

    /** Perform extra initialization of this action's singleton.
     * PLEASE do not use constructors for this purpose!
    protected void initialize () 
    {
	super.initialize ();
        putProperty (Action.SHORT_DESCRIPTION, NbBundle.getMessage (RefreshNodeAction.class, "HINT_Action"));
    }
    */

}
