package cz.cuni.dsrg.sofa.netbeans.visualdesigner.explorer.properties;

import cz.cuni.dsrg.sofa.netbeans.visualdesigner.typemanager.TypeEditor;
import cz.cuni.dsrg.sofa.netbeans.visualdesigner.types.Module;
import cz.cuni.dsrg.sofa.netbeans.visualdesigner.types.Repository;
import org.openide.nodes.PropertySupport;

import java.beans.PropertyEditor;

/**
 * Using this property, the developer can specify a module where to
 * store the types (interfaces and frames) that are created automatically,
 * when constructing a component.
 *
 * @author Michael Cifka
 */
public class PropDefaultModule extends PropertySupport.ReadWrite
{
    private Repository repository;

    public PropDefaultModule(Repository r)
    {
        super("defaultModule", Module.class, "Default Module", null);
        setValue("canEditAsText", Boolean.FALSE);
        setValue("changeImmediate", Boolean.FALSE);
        repository = r;
    }

    public Object getValue()
    {
        return repository.getDefaultModule();
    }

    public void setValue(Object val)
    {
        repository.setDefaultModule(((Module) val).getFullName());
    }

    public PropertyEditor getPropertyEditor()
    {
        TypeEditor editor = new TypeEditor(repository)
        {
            public String getAsText()
            {
                return ((Module) PropDefaultModule.this.getValue()).getScopeNameVersion();
            }
        };
        editor.setRequiredClass(Module.class);
        return editor;
    }
}