package cz.cuni.dsrg.sofa.netbeans.visualdesigner.explorer.properties;

import cz.cuni.dsrg.sofa.netbeans.visualdesigner.typemanager.TypeEditor;
import cz.cuni.dsrg.sofa.netbeans.visualdesigner.typemanager.TypeManager;
import cz.cuni.dsrg.sofa.netbeans.visualdesigner.types.AModule;
import cz.cuni.dsrg.sofa.netbeans.visualdesigner.types.Repository;
import org.openide.nodes.PropertySupport;

import java.beans.PropertyEditor;

/**
 * Using this property, the developer can specify a provider or
 * an architecture module where to store the architectures that
 * are created automatically, when constructing a component.
 *
 * @author Michael Cifka
 */
public class
        PropDefaultProvider extends PropertySupport.ReadWrite
{
    private Repository repository;

    public PropDefaultProvider(Repository r)
    {
        super("defaultProvider", AModule.class, "Default Provider", null);
        setValue("canEditAsText", Boolean.FALSE);
        setValue("changeImmediate", Boolean.FALSE);
        repository = r;
    }

    public Object getValue()
    {
        return repository.getDefaultProvider();
    }

    public void setValue(Object val)
    {
        repository.setDefaultProvider(((AModule) val).getFullName());
        TypeManager manager = TypeManager.get(repository);
        manager.refresh();
    }

    public PropertyEditor getPropertyEditor()
    {
        TypeEditor editor = new TypeEditor(repository)
        {
            public String getAsText()
            {
                return ((AModule) PropDefaultProvider.this.getValue()).getScopeNameVersion();
            }
        };
        editor.setRequiredClass(AModule.class);
        return editor;
    }
}