package cz.cuni.dsrg.sofa.netbeans.visualdesigner.explorer.properties;

import cz.cuni.dsrg.sofa.netbeans.visualdesigner.objects.PropertiesProvider;
import org.openide.nodes.PropertySupport;

/**
 * This property is used to edit a value of an integer property defined by the
 * component, allowing for the component customization.
 *
 * @author Michael Cifka
 */

public class PropIntegerValue extends PropertySupport.ReadWrite
{
    private PropertiesProvider provider;
    private String name;

    public PropIntegerValue(PropertiesProvider provider, String name)
    {
        super("integerProperty_" + name, Integer.class, "Property: " + name, null);
        setValue("canEditAsText", Boolean.TRUE);
        this.provider = provider;
        this.name = name;
    }


    public Object getValue()
    {
        return provider.getPropertyValue(name);
    }

    public void setValue(Object val)
    {
        provider.setPropertyValue(name, val);
    }
}