package cz.cuni.dsrg.sofa.netbeans.visualdesigner.explorer.properties;

import cz.cuni.dsrg.sofa.netbeans.visualdesigner.objects.PropertiesProvider;
import org.openide.explorer.propertysheet.ExPropertyEditor;
import org.openide.nodes.PropertySupport;

import java.beans.PropertyEditor;

/**
 * This property is used to invoke the {@link ProperitesPanel} that can be used
 * to providea custom property editor for defining the properties of a component,
 * variables predefined to customize
 * the behaviour of a component.
 *
 * Only properties of type Integer and String are implented.
 *
 * @author Michael Cifka
 */
public class PropProperties extends PropertySupport.ReadWrite
{
    private PropertiesProvider provider;

    public PropProperties(PropertiesProvider provider, String name, String label)
    {
        super(name, Object.class, label, null);
        setValue("canEditAsText", Boolean.FALSE);
        setValue("changeImmediate", Boolean.FALSE);
        this.provider = provider;
    }

    public Object getValue()
    {
        return null;
    }

    public void setValue(Object val)
    {
    }

    public PropertyEditor getPropertyEditor()
    {
        PropertiesEditor editor = new PropertiesEditor(provider);
        return editor;
    }

    class PropertiesEditor implements ExPropertyEditor
    {

        java.awt.Component customEditor;

        PropertiesEditor(PropertiesProvider provider)
        {
            customEditor = new PropertiesPanel(provider);
        }

        public void addPropertyChangeListener(java.beans.PropertyChangeListener propertyChangeListener)
        {
        }

        public void attachEnv(org.openide.explorer.propertysheet.PropertyEnv propertyEnv)
        {
        }

        public String getAsText()
        {
            String[] properties = provider.getProperties();
            if(properties.length == 0)
                return "(none)";
            else if(properties.length == 1)
                return "1 property";
            else
                return properties.length + " properties";
        }

        public java.awt.Component getCustomEditor()
        {
            return customEditor;
        }

        public String getJavaInitializationString()
        {
            return null;
        }

        public String[] getTags()
        {
            return null;
        }

        public Object getValue()
        {
            return null;
        }

        public boolean isPaintable()
        {
            return false;
        }

        public void paintValue(java.awt.Graphics graphics, java.awt.Rectangle rectangle)
        {
        }

        public void removePropertyChangeListener(java.beans.PropertyChangeListener propertyChangeListener)
        {
        }

        public void setAsText(String str) throws java.lang.IllegalArgumentException
        {
        }

        public void setValue(Object obj)
        {
        }

        public boolean supportsCustomEditor()
        {
            return true;
        }
    }
}