package cz.cuni.dsrg.sofa.netbeans.visualdesigner.loaders;

import org.openide.filesystems.FileObject;
import org.openide.loaders.DataObjectExistsException;
import org.openide.loaders.FileEntry;
import org.openide.loaders.MultiDataObject;
import org.openide.loaders.MultiFileLoader;

import java.io.IOException;

/**
 * The data loader for the SOFA Component Project (.sofa) file.
 * It allows the file to be recognized.
 *
 * @author Michael Cifka
 */
public class ComponentDataLoader extends MultiFileLoader
{
    public static final String MAIN_EXT = "sofa";

    public ComponentDataLoader()
    {
        super(ComponentDataObject.class);
    }

    protected MultiDataObject createMultiObject(FileObject primaryFile)
            throws DataObjectExistsException, IOException
    {
        return new ComponentDataObject(primaryFile, this);
    }


    protected FileObject findPrimaryFile(FileObject fo)
    {
        if(fo.hasExt(MAIN_EXT))
            return fo;
        else
            return null;
    }

    protected MultiDataObject.Entry createPrimaryEntry(MultiDataObject mdo, FileObject fo)
    {
        return new FileEntry(mdo, fo);
    }

    protected MultiDataObject.Entry createSecondaryEntry(MultiDataObject mdo, FileObject fo)
    {
        return new FileEntry(mdo, fo);
    }
}