package cz.cuni.dsrg.sofa.netbeans.visualdesigner.types;



/**
 * This class extends the {@link AbstractType} to hold, import, and export
 * the type information representing an architecture module, a folder able
 * to hold the architecture types.
 *
 * This class can be persisted using the Java Object Serialization.<p>
 *
 * @author Michael Cifka
 */
public class AModule extends AbstractType implements java.io.Serializable
{

    AModule()
    {
    }

    public AModule(String name)
    {
        this.name = name;
    }

    public String getFullName()
    {
///        if(parent==null) MiscHelps.message("Parent je null"); else MiscHelps.message("Parent je "+ parent.getName());

        return parent.getFullName() + "::" + getName();
    }

    public String writeAsCDL()
    {
        String s = "";
        AbstractType[] children = getChildren();
        for(int i = 0; i < children.length; i++)
            s += children[i].writeAsCDL();
        return s;
    }
}