package cz.cuni.dsrg.sofa.netbeans.visualdesigner.types;

/**
 * This class extends the {@link AbstractType} to hold, import, and export
 * the type information representing a provider, a top-level folder able
 * to hold the architecture types.<p>
 *
 * This class can be persisted using the Java Object Serialization.
 *
 * @author Michael Cifka
 */
public class Provider extends AModule implements java.io.Serializable
{

    Provider()
    {
    }

    public Provider(String name)
    {
        this.name = name;
    }

    public String getFullName()
    {
        return "::" + getName();
    }

    public String getModuleName()
    {
        return "::";
    }

    public String writeAsCDL()
    {
        String s = "";
        AbstractType[] children = getChildren();
        for(int i = 0; i < children.length; i++)
            s += children[i].writeAsCDL();
        return s;
    }
}